/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.gui;

import a0b36pr2_du2.rychly_balik.gui.table_models.DopravaTableModel;
import a0b36pr2_du2.rychly_balik.gui.table_models.SmenaTableModel;
import a0b36pr2_du2.rychly_balik.gui.table_models.ZasilkyTableModel;
import a0b36pr2_du2.rychly_balik.model.RychlyBalikDataService;
import a0b36pr2_du2.rychly_balik.model.RychlyBalikException;
import a0b36pr2_du2.rychly_balik.model.Zasilka;
import a0b36pr2_du2.rychly_balik.model.doprava.Doprava;
import a0b36pr2_du2.rychly_balik.model.personalistika.Pracovnik;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;

/**
 *
 * @author hapallen
 */
public class RychlyBalikGui extends JFrame {

    public enum Zalozka {

        ZASILKY("Zásilky"), VOZOVY_PARK("Vozový park"), SMENA("Pracovníci");
        private String name;

        private Zalozka(String name) {
            this.name = name;
        }

        @Override
        public String toString() {
            return this.name;
        }

        public static Zalozka getZalozkaByName(String name) {
            if (name.equals(Zalozka.SMENA.name)) {
                return Zalozka.SMENA;
            }
            if (name.equals(Zalozka.VOZOVY_PARK.name)) {
                return Zalozka.VOZOVY_PARK;
            }
            if (name.equals(Zalozka.ZASILKY.name)) {
                return Zalozka.ZASILKY;
            }
            return null;
        }
    }
    //prehled pracovniku
    //prehled vozoveho parku
    // prehled zasilek
    //formular pro pridani/editaci noveho pracovnika
    //formular zadani zasilky
    //formular pro pridani dopravniho prostredku
    RychlyBalikDataService dataModel;
    JMenuBar mainMenuBar;
    JMenu novyMenu;
    JMenuItem novaZasilkaMenuItem;
    JMenuItem novyPracovnikaMenuItem;
    JMenuItem novaDopravaMenuItem;
    JMenu dbMenu;
    JMenuItem connectDbMenuItem;
    JMenuItem disconnectDbMenuItem;
    JTabbedPane mainTabbedPane;
    JButton smazatButton;
    JTable zasilkyJTable;
    JTable pracovniciJTable;
    JTable vozovyParkJTable;
    JScrollPane zasilkyScrollPane;
    JScrollPane vozovyParkScrollPane;
    JScrollPane pracovniciScrollPane;
    JLabel dbConnectionStatusLabel;
    boolean isConnectedToDB = false;

    public RychlyBalikGui() {
        this(new RychlyBalikDataService());
    }

    public RychlyBalikGui(RychlyBalikDataService rychlyBalikData) {
        this.dataModel = rychlyBalikData;
        //nutne, aby se pri vypnuti okna vypla i aplikace
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);

        //nastaveni velkosti
        this.setSize(new Dimension(800, 600));
        this.setMinimumSize(new Dimension(600, 450));
        //dataModel.loadData();
        createGui();
        pack();
    }

    public void createGui() {
        mainMenuBar = new javax.swing.JMenuBar();
        dbConnectionStatusLabel = new JLabel();
        dbConnectionStatusLabel.setForeground(Color.red);
        novyMenu = new javax.swing.JMenu();
        novaZasilkaMenuItem = new javax.swing.JMenuItem();
        novyPracovnikaMenuItem = new javax.swing.JMenuItem();
        novaDopravaMenuItem = new javax.swing.JMenuItem();
        novyMenu.setText("Nový...");
        smazatButton = new JButton();
        smazatButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/trash-bin.gif")));
        smazatButton.setSize(20, 20);

        novaZasilkaMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Z, java.awt.event.InputEvent.CTRL_MASK));
        novaZasilkaMenuItem.setText("Nová zásilka");
        novaZasilkaMenuItem.setActionCommand("newZasilka");
        novyMenu.add(novaZasilkaMenuItem);

        novyPracovnikaMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.event.InputEvent.CTRL_MASK));
        novyPracovnikaMenuItem.setText("Nový pracovník");
        novyMenu.add(novyPracovnikaMenuItem);

        novaDopravaMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_D, java.awt.event.InputEvent.CTRL_MASK));
        novaDopravaMenuItem.setText("Nový dopravní prostředek");
        novyMenu.add(novaDopravaMenuItem);

        dbMenu = new javax.swing.JMenu();
        dbMenu.setText("Databáze");
        connectDbMenuItem = new javax.swing.JMenuItem();
        disconnectDbMenuItem = new javax.swing.JMenuItem();
        connectDbMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.event.InputEvent.CTRL_MASK));
        connectDbMenuItem.setText("Připojit k DB");
        disconnectDbMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
        disconnectDbMenuItem.setText("Odpojit od DB");
        dbMenu.add(connectDbMenuItem);
        dbMenu.add(disconnectDbMenuItem);

        mainMenuBar.add(novyMenu);
        mainMenuBar.add(dbMenu);
        mainMenuBar.add(dbConnectionStatusLabel);
        setJMenuBar(mainMenuBar);

        mainTabbedPane = new javax.swing.JTabbedPane();


        zasilkyJTable = new JTable(new ZasilkyTableModel(dataModel.
                getSeznamZasilek()));
        zasilkyJTable.setFocusable(true);
        pracovniciJTable = new JTable(new SmenaTableModel(dataModel.getSmena().
                getSeznamPracovniku()));
        pracovniciJTable.setFocusable(true);
        vozovyParkJTable = new JTable(new DopravaTableModel(dataModel.
                getVozovyPark().getSeznam()));
        vozovyParkJTable.setFocusable(true);

        zasilkyScrollPane = new javax.swing.JScrollPane();
        zasilkyScrollPane.setName(Zalozka.ZASILKY.name);
        vozovyParkScrollPane = new javax.swing.JScrollPane();
        vozovyParkScrollPane.setName(Zalozka.VOZOVY_PARK.name);
        pracovniciScrollPane = new javax.swing.JScrollPane();
        pracovniciScrollPane.setName(Zalozka.SMENA.name);
        zasilkyScrollPane.setViewportView(zasilkyJTable);
        pracovniciScrollPane.setViewportView(pracovniciJTable);
        vozovyParkScrollPane.setViewportView(vozovyParkJTable);
        mainTabbedPane.addTab(Zalozka.ZASILKY.name, zasilkyScrollPane);
        mainTabbedPane.addTab(Zalozka.SMENA.name, pracovniciScrollPane);
        mainTabbedPane.addTab(Zalozka.VOZOVY_PARK.name, vozovyParkScrollPane);


        Container container = getContentPane();
        container.add(smazatButton, BorderLayout.SOUTH);
        container.add(mainTabbedPane, BorderLayout.CENTER);

        novyPracovnikaMenuItem.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                EditPracovnikJDialog novyPracovnik =
                        new EditPracovnikJDialog(RychlyBalikGui.this, true, dataModel);
                novyPracovnik.setVisible(true);
            }
        });

        novaZasilkaMenuItem.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                EditZasilkaJDialog novaZasilkaJDialog =
                        new EditZasilkaJDialog(RychlyBalikGui.this, true, dataModel);
                novaZasilkaJDialog.setVisible(true);
            }
        });
        novaDopravaMenuItem.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                EditDopravaJDialog novaDoprava =
                        new EditDopravaJDialog(RychlyBalikGui.this, true, dataModel);
                novaDoprava.setVisible(true);
            }
        });

        connectDbMenuItem.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                ConnectDbJDialog connectDbDialog =
                        new ConnectDbJDialog(RychlyBalikGui.this, true, dataModel);
                connectDbDialog.setVisible(true);
            }
        });

        disconnectDbMenuItem.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                disconnectDb();
            }
        });

        smazatButton.addActionListener(new ObsluhaSmazatButton());
        aktualizujGui();
        pack();
    }

    public void disconnectDb() {
        //skutecne se chcete odpojit
        int result =
                JOptionPane.showConfirmDialog(this, "Skutecne se chcete odpojit od DB", "Odpojit DB", JOptionPane.OK_CANCEL_OPTION);
        if (result == JOptionPane.OK_OPTION) {
            try {
                dataModel.getDbService().closeConnection();
                this.isConnectedToDB = false;
                setDisconnectedLabel();
            } catch (RychlyBalikException re) {
                Logger.getLogger(RychlyBalikGui.class.getName()).
                        log(Level.SEVERE, null, re);
                JOptionPane.showMessageDialog(null,
                        "Chyba pri uzavirani spojeni s DB: " + re.getMessage(), "Chyba pri uzavirani spojeni s DB", JOptionPane.ERROR_MESSAGE);
            }
        }
    }

    public boolean isIsConnectedToDB() {
        return isConnectedToDB;
    }

    public void setIsConnectedToDB(boolean isConnectedToDB) {
        this.isConnectedToDB = isConnectedToDB;
    }



    private void setConnectedLabel() {
        dbConnectionStatusLabel.setText("DB připojena");
        dbConnectionStatusLabel.setForeground(Color.GREEN);
        dbConnectionStatusLabel.repaint();
    }

    private void setDisconnectedLabel() {
        dbConnectionStatusLabel.setText("DB odpojena");
        dbConnectionStatusLabel.setForeground(Color.RED);
        dbConnectionStatusLabel.repaint();
    }

    public void aktualizujGui() {
        if (this.isConnectedToDB) {
            setConnectedLabel();
        } else {
            setDisconnectedLabel();
        }
        mainTabbedPane.validate();
        mainTabbedPane.repaint();
        aktualizujPracovniciGui();
        aktualizujVozovyParkGui();
        aktualizujZasilkyGui();
    }

    protected void aktualizujPracovniciGui() {
        SmenaTableModel model = (SmenaTableModel) pracovniciJTable.getModel();
        model.fireTableDataChanged();

    }

    protected void aktualizujZasilkyGui() {
        ZasilkyTableModel model = (ZasilkyTableModel) zasilkyJTable.getModel();
        model.fireTableDataChanged();
    }

    protected void aktualizujVozovyParkGui() {
        DopravaTableModel model =
                (DopravaTableModel) vozovyParkJTable.getModel();
        model.fireTableDataChanged();
    }

    class ObsluhaSmazatButton implements ActionListener {

        public void actionPerformed(ActionEvent e) {
            if (mainTabbedPane.getSelectedComponent() instanceof JScrollPane) {
                JScrollPane scroll = (JScrollPane) mainTabbedPane.
                        getSelectedComponent();
                Zalozka zalozka = Zalozka.getZalozkaByName(scroll.getName());
                try {
                    switch (zalozka) {
                        case ZASILKY:
                            if (zasilkyJTable.getSelectedRow() != -1) {
                                ZasilkyTableModel model = (ZasilkyTableModel) zasilkyJTable.
                                        getModel();
                                Zasilka zasilka = model.getValueAtRow(zasilkyJTable.
                                        getSelectedRow());
                                dataModel.odeberZasilku(zasilka);
                                model.fireTableRowsDeleted(zasilkyJTable.
                                        getSelectedRow(), zasilkyJTable.
                                        getSelectedRow());
                                System.out.println("remove from zasilky  - zasilka: " + zasilka);
                            }
                            break;
                        case SMENA:
                            if (pracovniciJTable.getSelectedRow() != -1) {
                                SmenaTableModel model = (SmenaTableModel) pracovniciJTable.
                                        getModel();
                                Pracovnik pracovnik = (Pracovnik) model.
                                        getValueAtRow(pracovniciJTable.
                                        getSelectedRow());
                                // model.removeElementAt(pracovniciJTable.getSelectedIndex());
                                dataModel.odeberPracovnika(pracovnik);
                                model.fireTableRowsDeleted(pracovniciJTable.
                                        getSelectedRow(), pracovniciJTable.
                                        getSelectedRow());
                                System.out.println("remove from pracovnici  - pracovnik: " + pracovnik);
                            }
                            break;
                        case VOZOVY_PARK:
                            if (vozovyParkJTable.getSelectedRow() != -1) {
                                DopravaTableModel model = (DopravaTableModel) vozovyParkJTable.
                                        getModel();
                                Doprava doprava = (Doprava) model.getValueAtRow(vozovyParkJTable.
                                        getSelectedRow());
                                // model.removeElementAt(pracovniciJTable.getSelectedIndex());
                                dataModel.odeberDopravniProstredek(doprava);
                                model.fireTableRowsDeleted(vozovyParkJTable.
                                        getSelectedRow(), vozovyParkJTable.
                                        getSelectedRow());
                                System.out.println("remove from vozovy park  - doprava: " + doprava);
                            }
                            break;
                        default:
                            throw new RychlyBalikException("Nebyla vybrana zadna zalozka");
                    }

                    // odebiralo se jen z datoveho modelu a je treba ted aktualizovat gui
                    //aktualizujGui();
                } catch (RychlyBalikException re) {
                    JOptionPane.showMessageDialog(null,
                            "Chyba pri mazani objektu: " + re.getMessage(), "Chyba pri odebirani ze zalozky " + zalozka, JOptionPane.ERROR_MESSAGE);
                }
            }
        }
    }
}
