/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.model.doprava;

import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author hapallen
 */
public abstract class Doprava {

    private Integer id;
    public static final String TO_STRING_FORMAT =
            "%15s: %10.2f kg - %10.2f km/h - %10.2f Kč/km";

    abstract public double getNosnost();

    abstract public double getCenaZaVzdalenost(double vzdalenost);

    abstract public double getRychlost();

    abstract public TypDopravy getTypDopravy();

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public static String[] getDescriptor() {
        return new String[]{"Typ", "Nosnost", "Rychlost", "Cena za km"};
    }

    public Map getAsMap() {
        //new String[]{"Typ", "Nosnost", "Rychlost", "Cena za km"};
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("Typ", getTypDopravy().getName());
        map.put("Nosnost", getNosnost());
        map.put("Rychlost", getRychlost());
        double zaokrouhlenaCena = getCenaZaVzdalenost(1) * 100;
        zaokrouhlenaCena = (int) zaokrouhlenaCena / 100.0;
        map.put("Cena za km", zaokrouhlenaCena);
        return map;
    }

    public enum TypDopravy {

        UNKNOW("nezadáno", true, true), DODAVKA("Dodávka", false, false), KOLO("Kolo", true, true), MHD("MHD", true, false), PICK_UP("Pickup", true, false);
        private String name;
        private boolean nosnostEditable;
        private boolean rychlostEditable;

        private TypDopravy(String name, boolean nosnostEditable, boolean rychlostEditable) {
            this.name = name;
            this.nosnostEditable = nosnostEditable;
            this.rychlostEditable = rychlostEditable;
        }

        public String getName() {
            return name;
        }

        public boolean isNosnostEditable() {
            return nosnostEditable;
        }

        public boolean isRychlostEditable() {
            return rychlostEditable;
        }

        @Override
        public String toString() {
            return this.name;
        }
    }
}
