/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.model.doprava;

import a0b36pr2_du2.rychly_balik.model.RychlyBalikException;
import java.util.HashMap;
import java.util.Map;

/**
 *MHD, rychlost je 30km/hod, člověk unese maximálně 15 kg a cena je 200 kč/hodinu.
 * @author hapallen
 */
public class Mhd extends Doprava {

    public static final double RYCHLOST = 30; // RYCHLOST km/hod
    private static final double MAX_NOSNOST = 15; // nosnost v kg, ruzne kola mohou mit ruznou
    private double nosnost;

    /**
     * konstruktor umoznuje nastavit jen max povolenou nosnost
     * @param nosnost
     */
    public Mhd(double nosnost) throws RychlyBalikException {
        setNosnost(nosnost);
    }

    public void setNosnost(double nosnost) throws RychlyBalikException {
        this.nosnost = nosnost;
        if (nosnost <= 0.0) {
            throw new RychlyBalikException("Nosnost musi byt kladna.");
        }
        if (nosnost > MAX_NOSNOST) {
            throw new RychlyBalikException("Prekrocena max nosnost cloveka v MHD (" + MAX_NOSNOST + " kg).");
        }
    }

    public double getNosnost() {
        return nosnost;
    }

    @Override
    public double getRychlost() {
        return RYCHLOST;
    }

    public double getCenaZaVzdalenost(double vzdalenost) {
        return 200 * (vzdalenost / RYCHLOST);
    }

    @Override
    public String toString() {
        return String.format(TO_STRING_FORMAT, getTypDopravy().name(), getNosnost(), RYCHLOST, getCenaZaVzdalenost(1));
    }

    @Override
    public TypDopravy getTypDopravy() {
        return TypDopravy.MHD;
    }
}
